#/bin/sh

if [ $2 = e ]; then #for embedding file

	file_to_hide=$(kdialog --getopenfilename .) #choose which file to embed
	
	if [ $? = 0 ]; then #if user does't press cancel
	
		#comparing if passwords match
		pass=$(kdialog --password "Choose password")
		pass2=$(kdialog --password "Retype password (for sure)")
		if [ $pass = $pass2 ]; then
			kdialog --yesno "Replace original file?"
			if [ $? = 0 ]; then
				steghide embed -cf "$1" -ef "$file_to_hide" -p "$pass"
			else
				file_to_save=$(kdialog --getsavefilename .)
				if [ $? = 0 ]; then
					wrong=$(steghide embed -cf "$1" -ef "$file_to_hide" -p "$pass" -sf "$file_to_save")
					if [ $wrong = 1 ]; then
						kdialog --error "Steghide ended with error"
					fi
				fi
			fi
		else
			kdialog --sorry "Passwords don't match. Ending script."
		fi
	fi

else #for extracting file
	current_path=$(echo ${1%/*}) #where is the file which should contain embedded file
	
	pass=$(kdialog --password "Type password")
	
	#testing if the file realy contain another file and if so, getting its name
	name=$(steghide info $1 -p "$pass" | grep "embedded file" | awk '{print $3}')
	name=$(echo ${name%'":'})
	name=$(echo ${name#'"'})
	
	if [ ${#name} == 0 ]; then
		kdialog --sorry "This file doesn't contain any embedded file or the password is wrong."
	else
		if [[ -f "$current_path/$name" ]]; then #if the name of the embedded file is allready used in this directory, user have to choose another name for saving this file
			kdialog --sorry "The embedded file would be saved as $current_path/$name but this file allready exists. Choose another place."
			file_to_save=$(kdialog --getsavefilename .)
			if [ $? = 0 ]; then				
				wrong=$(steghide extract -sf "$1" -xf "$file_to_save" -p "$pass")
				if [ $wrong = 1 ]; then
					kdialog --error "Steghide ended with error"
				fi
			fi
		else #if the name is possible to use, script just inform the user where the file was saved
			wrong=$(steghide extract -sf "$1" -p "$pass")
			if [ $wrong = 1 ]; then
				kdialog --error "Steghide ended with error"
			else				
				kdialog --msgbox "The embedded file was saved as $current_path/$name."
			fi
		fi
	fi
fi
